<!doctype html>
<html>
<head>
    <title>New alpha release: Tor 0.4.1.1-alpha | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="New alpha release: Tor 0.4.1.1-alpha | Tor Project">
    <meta property="og:description" content="There&#39;s a new alpha release available for download. If you build Tor from source, you can download the source code for 0.4.1.1-alpha from the usual place on the website. Packages should be available over the coming weeks, with a new alpha Tor Browser release in the next couple of weeks. Remember, this is an alpha release: you should only run this if you&#39;d like to find and report more bugs than usual. This is the first alpha in the 0.4.1.x series. It introduces lightweight circuit padding to make some onion-service circuits harder to distinguish, includes a new &#34;authenticated SENDME&#34; feature to make certain denial-of-service attacks more difficult, and improves performance in several areas. Changes in version 0.4.1.1-alpha - 2019-05-22 Major features (circuit padding): Onion service clients now add padding cells at the start of their INTRODUCE and RENDEZVOUS circuits, to make those circuits&#39; traffic look more like general purpose Exit traffic. The overhead for this is 2 extra cells in each direction for RENDEZVOUS circuits, and 1 extra upstream cell and 10 downstream cells for INTRODUCE circuits. This feature is only enabled when also supported by the circuit&#39;s middle node. (Clients may specify fixed middle nodes with the MiddleNodes option, and may force-disable this feature with the CircuitPadding torrc.) Closes ticket 28634. Major features (code organization): Tor now includes a generic publish-subscribe message-passing subsystem that we can use to organize intermodule dependencies. We hope to use this to reduce dependencies between modules that don&#39;t need to be related, and to generally simplify our codebase. Closes ticket 28226.">
    <meta property="og:image" content="https://blog.torproject.org/new-alpha-release-tor-0411-alpha/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/new-alpha-release-tor-0411-alpha/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        New alpha release: Tor 0.4.1.1-alpha
      </h1>
    <p class="meta">by nickm | May 22, 2019</p>
    <picture>
      
      <img class="lead" src="lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>There's a new alpha release available for download. If you build Tor from source, you can download the source code for 0.4.1.1-alpha from the usual place on the website. Packages should be available over the coming weeks, with a new alpha Tor Browser release in the next couple of weeks.</p>
<p>Remember, this is an alpha release: you should only run this if you'd like to find and report more bugs than usual.</p>
<p>This is the first alpha in the 0.4.1.x series. It introduces lightweight circuit padding to make some onion-service circuits harder to distinguish, includes a new "authenticated SENDME" feature to make certain denial-of-service attacks more difficult, and improves performance in several areas.</p>
<h2>Changes in version 0.4.1.1-alpha - 2019-05-22</h2>
<ul>
<li>Major features (circuit padding):
<ul>
<li>Onion service clients now add padding cells at the start of their INTRODUCE and RENDEZVOUS circuits, to make those circuits' traffic look more like general purpose Exit traffic. The overhead for this is 2 extra cells in each direction for RENDEZVOUS circuits, and 1 extra upstream cell and 10 downstream cells for INTRODUCE circuits. This feature is only enabled when also supported by the circuit's middle node. (Clients may specify fixed middle nodes with the MiddleNodes option, and may force-disable this feature with the CircuitPadding torrc.) Closes ticket <a href="https://bugs.torproject.org/28634">28634</a>.</li>
</ul>
</li>
<li>Major features (code organization):
<ul>
<li>Tor now includes a generic publish-subscribe message-passing subsystem that we can use to organize intermodule dependencies. We hope to use this to reduce dependencies between modules that don't need to be related, and to generally simplify our codebase. Closes ticket <a href="https://bugs.torproject.org/28226">28226</a>.</li>
</ul>
</li>
</ul>
<p> </p>
<!--break--><ul>
<li>Major features (controller protocol):
<ul>
<li>Controller commands are now parsed using a generalized parsing subsystem. Previously, each controller command was responsible for parsing its own input, which led to strange inconsistencies. Closes ticket <a href="https://bugs.torproject.org/30091">30091</a>.</li>
</ul>
</li>
<li>Major features (flow control):
<ul>
<li>Implement authenticated SENDMEs as detailed in proposal 289. A SENDME cell now includes the digest of the traffic that it acknowledges, so that once an end point receives the SENDME, it can confirm the other side's knowledge of the previous cells that were sent, and prevent certain types of denial-of-service attacks. This behavior is controlled by two new consensus parameters: see the proposal for more details. Fixes ticket <a href="https://bugs.torproject.org/26288">26288</a>.</li>
</ul>
</li>
<li>Major features (performance):
<ul>
<li>Our node selection algorithm now excludes nodes in linear time. Previously, the algorithm was quadratic, which could slow down heavily used onion services. Closes ticket <a href="https://bugs.torproject.org/30307">30307</a>.</li>
</ul>
</li>
<li>Major features (performance, RNG):
<ul>
<li>Tor now constructs a fast secure pseudorandom number generator for each thread, to use when performance is critical. This PRNG is based on AES-CTR, using a buffering construction similar to libottery and the (newer) OpenBSD arc4random() code. It outperforms OpenSSL 1.1.1a's CSPRNG by roughly a factor of 100 for small outputs. Although we believe it to be cryptographically strong, we are only using it when necessary for performance. Implements tickets 29023 and 29536.</li>
</ul>
</li>
<li>Major bugfixes (onion service v3):
<ul>
<li>Fix an unreachable bug in which an introduction point could try to send an INTRODUCE_ACK with a status code that Trunnel would refuse to encode, leading the relay to assert(). We've consolidated the ABI values into Trunnel now. Fixes bug <a href="https://bugs.torproject.org/30454">30454</a>; bugfix on 0.3.0.1-alpha.</li>
<li>Clients can now handle unknown status codes from INTRODUCE_ACK cells. (The NACK behavior will stay the same.) This will allow us to extend status codes in the future without breaking the normal client behavior. Fixes another part of bug <a href="https://bugs.torproject.org/30454">30454</a>; bugfix on 0.3.0.1-alpha.</li>
</ul>
</li>
<li>Minor features (circuit padding):
<ul>
<li>We now use a fast PRNG when scheduling circuit padding. Part of ticket <a href="https://bugs.torproject.org/28636">28636</a>.</li>
<li>Allow the padding machine designer to pick the edges of their histogram instead of trying to compute them automatically using an exponential formula. Resolves some undefined behavior in the case of small histograms and allows greater flexibility on machine design. Closes ticket <a href="https://bugs.torproject.org/29298">29298</a>; bugfix on 0.4.0.1-alpha.</li>
<li>Allow circuit padding machines to hold a circuit open until they are done padding it. Closes ticket <a href="https://bugs.torproject.org/28780">28780</a>.</li>
</ul>
</li>
<li>Minor features (compile-time modules):
<ul>
<li>Add a "--list-modules" command to print a list of which compile- time modules are enabled. Closes ticket <a href="https://bugs.torproject.org/30452">30452</a>.</li>
</ul>
</li>
<li>Minor features (continuous integration):
<ul>
<li>Remove sudo configuration lines from .travis.yml as they are no longer needed with current Travis build environment. Resolves issue <a href="https://bugs.torproject.org/30213">30213</a>.</li>
<li>In Travis, show stem's tor log after failure. Closes ticket <a href="https://bugs.torproject.org/30234">30234</a>.</li>
</ul>
</li>
<li>Minor features (controller):
<ul>
<li>Add onion service version 3 support to the HSFETCH command. Previously, only version 2 onion services were supported. Closes ticket <a href="https://bugs.torproject.org/25417">25417</a>. Patch by Neel Chauhan.</li>
</ul>
</li>
<li>Minor features (debugging):
<ul>
<li>Introduce tor_assertf() and tor_assertf_nonfatal() to enable logging of additional information during assert failure. Now we can use format strings to include information for trouble shooting. Resolves ticket <a href="https://bugs.torproject.org/29662">29662</a>.</li>
</ul>
</li>
<li>Minor features (defense in depth):
<ul>
<li>In smartlist_remove_keeporder(), set unused pointers to NULL, in case a bug causes them to be used later. Closes ticket <a href="https://bugs.torproject.org/30176">30176</a>. Patch from Tobias Stoeckmann.</li>
<li>Tor now uses a cryptographically strong PRNG even for decisions that we do not believe are security-sensitive. Previously, for performance reasons, we had used a trivially predictable linear congruential generator algorithm for certain load-balancing and statistical sampling decisions. Now we use our fast RNG in those cases. Closes ticket <a href="https://bugs.torproject.org/29542">29542</a>.</li>
</ul>
</li>
<li>Minor features (developer tools):
<ul>
<li>Tor's "practracker" test script now checks for files and functions that seem too long and complicated. Existing overlong functions and files are accepted for now, but should eventually be refactored. Closes ticket <a href="https://bugs.torproject.org/29221">29221</a>.</li>
<li>Add some scripts used for git maintenance to scripts/git. Closes ticket <a href="https://bugs.torproject.org/29391">29391</a>.</li>
<li>Call practracker from pre-push and pre-commit git hooks to let developers know if they made any code style violations. Closes ticket <a href="https://bugs.torproject.org/30051">30051</a>.</li>
<li>Add a script to check that each header has a well-formed and unique guard macro. Closes ticket <a href="https://bugs.torproject.org/29756">29756</a>.</li>
</ul>
</li>
<li>Minor features (geoip):
<ul>
<li>Update geoip and geoip6 to the May 13 2019 Maxmind GeoLite2 Country database. Closes ticket <a href="https://bugs.torproject.org/30522">30522</a>.</li>
</ul>
</li>
<li>Minor features (HTTP tunnel):
<ul>
<li>Return an informative web page when the HTTPTunnelPort is used as an HTTP proxy. Closes ticket <a href="https://bugs.torproject.org/27821">27821</a>, patch by "eighthave".</li>
</ul>
</li>
<li>Minor features (IPv6, v3 onion services):
<ul>
<li>Make v3 onion services put IPv6 addresses in service descriptors. Before this change, service descriptors only contained IPv4 addresses. Implements 26992.</li>
</ul>
</li>
<li>Minor features (modularity):
<ul>
<li>The "--disable-module-dirauth" compile-time option now disables even more dirauth-only code. Closes ticket <a href="https://bugs.torproject.org/30345">30345</a>.</li>
</ul>
</li>
<li>Minor features (performance):
<ul>
<li>Use OpenSSL's implementations of SHA3 when available (in OpenSSL 1.1.1 and later), since they tend to be faster than tiny-keccak. Closes ticket <a href="https://bugs.torproject.org/28837">28837</a>.</li>
</ul>
</li>
<li>Minor features (testing):
<ul>
<li>Tor's unit test code now contains helper functions to replace the PRNG with a deterministic or reproducible version for testing. Previously, various tests implemented this in various ways. Implements ticket <a href="https://bugs.torproject.org/29732">29732</a>.</li>
<li>We now have a script, cov-test-determinism.sh, to identify places where our unit test coverage has become nondeterministic. Closes ticket <a href="https://bugs.torproject.org/29436">29436</a>.</li>
<li>Check that representative subsets of values of `int` and `unsigned int` can be represented by `void *`. Resolves issue <a href="https://bugs.torproject.org/29537">29537</a>.</li>
</ul>
</li>
<li>Minor bugfixes (bridge authority):
<ul>
<li>Bridge authorities now set bridges as running or non-running when about to dump their status to a file. Previously, they set bridges as running in response to a GETINFO command, but those shouldn't modify data structures. Fixes bug <a href="https://bugs.torproject.org/24490">24490</a>; bugfix on 0.2.0.13-alpha. Patch by Neel Chauhan.</li>
</ul>
</li>
<li>Minor bugfixes (channel padding statistics):
<ul>
<li>Channel padding write totals and padding-enabled totals are now counted properly in relay extrainfo descriptors. Fixes bug <a href="https://bugs.torproject.org/29231">29231</a>; bugfix on 0.3.1.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (circuit padding):
<ul>
<li>Add a "CircuitPadding" torrc option to disable circuit padding. Fixes bug <a href="https://bugs.torproject.org/28693">28693</a>; bugfix on 0.4.0.1-alpha.</li>
<li>Allow circuit padding machines to specify that they do not contribute much overhead, and provide consensus flags and torrc options to force clients to only use these low overhead machines. Fixes bug <a href="https://bugs.torproject.org/29203">29203</a>; bugfix on 0.4.0.1-alpha.</li>
<li>Provide a consensus parameter to fully disable circuit padding, to be used in emergency network overload situations. Fixes bug <a href="https://bugs.torproject.org/30173">30173</a>; bugfix on 0.4.0.1-alpha.</li>
<li>The circuit padding subsystem will no longer schedule padding if dormant mode is enabled. Fixes bug <a href="https://bugs.torproject.org/28636">28636</a>; bugfix on 0.4.0.1-alpha.</li>
<li>Inspect a circuit-level cell queue before sending padding, to avoid sending padding while too much data is already queued. Fixes bug <a href="https://bugs.torproject.org/29204">29204</a>; bugfix on 0.4.0.1-alpha.</li>
<li>Avoid calling monotime_absolute_usec() in circuit padding machines that do not use token removal or circuit RTT estimation. Fixes bug <a href="https://bugs.torproject.org/29085">29085</a>; bugfix on 0.4.0.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (compilation, unusual configurations):
<ul>
<li>Avoid failures when building with the ALL_BUGS_ARE_FATAL option due to missing declarations of abort(), and prevent other such failures in the future. Fixes bug <a href="https://bugs.torproject.org/30189">30189</a>; bugfix on 0.3.4.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (controller protocol):
<ul>
<li>Teach the controller parser to distinguish an object preceded by an argument list from one without. Previously, it couldn't distinguish an argument list from the first line of a multiline object. Fixes bug <a href="https://bugs.torproject.org/29984">29984</a>; bugfix on 0.2.3.8-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (directory authority, ipv6):
<ul>
<li>Directory authorities with IPv6 support now always mark themselves as reachable via IPv6. Fixes bug <a href="https://bugs.torproject.org/24338">24338</a>; bugfix on 0.4.0.2-alpha. Patch by Neel Chauhan.</li>
</ul>
</li>
<li>Minor bugfixes (documentation):
<ul>
<li>Improve the documentation for using MapAddress with ".exit". Fixes bug <a href="https://bugs.torproject.org/30109">30109</a>; bugfix on 0.1.0.1-rc.</li>
<li>Improve the monotonic time module and function documentation to explain what "monotonic" actually means, and document some results that have surprised people. Fixes bug <a href="https://bugs.torproject.org/29640">29640</a>; bugfix on 0.2.9.1-alpha.</li>
<li>Use proper formatting when providing an example on quoting options that contain whitespace. Fixes bug <a href="https://bugs.torproject.org/29635">29635</a>; bugfix on 0.2.3.18-rc.</li>
</ul>
</li>
<li>Minor bugfixes (logging):
<ul>
<li>Do not log a warning when running with an OpenSSL version other than the one Tor was compiled with, if the two versions should be compatible. Previously, we would warn whenever the version was different. Fixes bug <a href="https://bugs.torproject.org/30190">30190</a>; bugfix on 0.2.4.2-alpha.</li>
<li>Warn operators when the MyFamily option is set but ContactInfo is missing, as the latter should be set too. Fixes bug <a href="https://bugs.torproject.org/25110">25110</a>; bugfix on 0.3.3.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (memory leak):
<ul>
<li>Avoid a minor memory leak that could occur on relays when failing to create a "keys" directory. Fixes bug <a href="https://bugs.torproject.org/30148">30148</a>; bugfix on 0.3.3.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (onion services):
<ul>
<li>Avoid a GCC 9.1.1 warning (and possible crash depending on libc implemenation) when failing to load an onion service client authorization file. Fixes bug <a href="https://bugs.torproject.org/30475">30475</a>; bugfix on 0.3.5.1-alpha.</li>
<li>When refusing to launch a controller's HSFETCH request because of rate-limiting, respond to the controller with a new response, "QUERY_RATE_LIMITED". Previously, we would log QUERY_NO_HSDIR for this case. Fixes bug <a href="https://bugs.torproject.org/28269">28269</a>; bugfix on 0.3.1.1-alpha. Patch by Neel Chauhan.</li>
<li>When relaunching a circuit to a rendezvous service, mark the circuit as needing high-uptime routers as appropriate. Fixes bug <a href="https://bugs.torproject.org/17357">17357</a>; bugfix on 0.4.0.2-alpha. Patch by Neel Chauhan.</li>
<li>Stop ignoring IPv6 link specifiers sent to v3 onion services. (IPv6 support for v3 onion services is still incomplete: see ticket <a href="https://bugs.torproject.org/23493">23493</a> for details.) Fixes bug <a href="https://bugs.torproject.org/23588">23588</a>; bugfix on 0.3.2.1-alpha. Patch by Neel Chauhan.</li>
</ul>
</li>
<li>Minor bugfixes (onion services, performance):
<ul>
<li>When building circuits to onion services, call tor_addr_parse() less often. Previously, we called tor_addr_parse() in circuit_is_acceptable() even if its output wasn't used. This change should improve performance when building circuits. Fixes bug <a href="https://bugs.torproject.org/22210">22210</a>; bugfix on 0.2.8.12. Patch by Neel Chauhan.</li>
</ul>
</li>
<li>Minor bugfixes (performance):
<ul>
<li>When checking whether a node is a bridge, use a fast check to make sure that its identity is set. Previously, we used a constant-time check, which is not necessary in this case. Fixes bug <a href="https://bugs.torproject.org/30308">30308</a>; bugfix on 0.3.5.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (pluggable transports):
<ul>
<li>Tor now sets TOR_PT_EXIT_ON_STDIN_CLOSE=1 for client transports as well as servers. Fixes bug <a href="https://bugs.torproject.org/25614">25614</a>; bugfix on 0.2.7.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (probability distributions):
<ul>
<li>Refactor and improve parts of the probability distribution code that made Coverity complain. Fixes bug <a href="https://bugs.torproject.org/29805">29805</a>; bugfix on 0.4.0.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (python):
<ul>
<li>Stop assuming that /usr/bin/python3 exists. For scripts that work with python2, use /usr/bin/python. Otherwise, use /usr/bin/env python3. Fixes bug <a href="https://bugs.torproject.org/29913">29913</a>; bugfix on 0.2.5.3-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (relay):
<ul>
<li>When running as a relay, if IPv6Exit is set to 1 while ExitRelay is auto, act as if ExitRelay is 1. Previously, we would ignore IPv6Exit if ExitRelay was 0 or auto. Fixes bug <a href="https://bugs.torproject.org/29613">29613</a>; bugfix on 0.3.5.1-alpha. Patch by Neel Chauhan.</li>
</ul>
</li>
<li>Minor bugfixes (stats):
<ul>
<li>When ExtraInfoStatistics is 0, stop including bandwidth usage statistics, GeoIPFile hashes, ServerTransportPlugin lines, and bridge statistics by country in extra-info documents. Fixes bug <a href="https://bugs.torproject.org/29018">29018</a>; bugfix on 0.2.4.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (testing):
<ul>
<li>Call setrlimit() to disable core dumps in test_bt_cl.c. Previously we used `ulimit -c` in test_bt.sh, which violates POSIX shell compatibility. Fixes bug <a href="https://bugs.torproject.org/29061">29061</a>; bugfix on 0.3.5.1-alpha.</li>
<li>Fix some incorrect code in the v3 onion service unit tests. Fixes bug <a href="https://bugs.torproject.org/29243">29243</a>; bugfix on 0.3.2.1-alpha.</li>
<li>In the "routerkeys/*" tests, check the return values of mkdir() for possible failures. Fixes bug <a href="https://bugs.torproject.org/29939">29939</a>; bugfix on 0.2.7.2-alpha. Found by Coverity as CID 1444254.</li>
<li>Split test_utils_general() into several smaller test functions. This makes it easier to perform resource deallocation on assert failure, and fixes Coverity warnings CID 1444117 and CID 1444118. Fixes bug <a href="https://bugs.torproject.org/29823">29823</a>; bugfix on 0.2.9.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (tor-resolve):
<ul>
<li>Fix a memory leak in tor-resolve that could happen if Tor gave it a malformed SOCKS response. (Memory leaks in tor-resolve don't actually matter, but it's good to fix them anyway.) Fixes bug <a href="https://bugs.torproject.org/30151">30151</a>; bugfix on 0.4.0.1-alpha.</li>
</ul>
</li>
<li>Code simplification and refactoring:
<ul>
<li>Abstract out the low-level formatting of replies on the control port. Implements ticket <a href="https://bugs.torproject.org/30007">30007</a>.</li>
<li>Add several assertions in an attempt to fix some Coverity warnings. Closes ticket <a href="https://bugs.torproject.org/30149">30149</a>.</li>
<li>Introduce a connection_dir_buf_add() helper function that checks for compress_state of dir_connection_t and automatically writes a string to directory connection with or without compression. Resolves issue <a href="https://bugs.torproject.org/28816">28816</a>.</li>
<li>Make the base32_decode() API return the number of bytes written, for consistency with base64_decode(). Closes ticket <a href="https://bugs.torproject.org/28913">28913</a>.</li>
<li>Move most relay-only periodic events out of mainloop.c into the relay subsystem. Closes ticket <a href="https://bugs.torproject.org/30414">30414</a>.</li>
<li>Refactor and encapsulate parts of the codebase that manipulate crypt_path_t objects. Resolves issue <a href="https://bugs.torproject.org/30236">30236</a>.</li>
<li>Refactor several places in our code that Coverity incorrectly believed might have memory leaks. Closes ticket <a href="https://bugs.torproject.org/30147">30147</a>.</li>
<li>Remove redundant return values in crypto_format, and the associated return value checks elsewhere in the code. Make the implementations in crypto_format consistent, and remove redundant code. Resolves ticket <a href="https://bugs.torproject.org/29660">29660</a>.</li>
<li>Rename tor_mem_is_zero() to fast_mem_is_zero(), to emphasize that it is not a constant-time function. Closes ticket <a href="https://bugs.torproject.org/30309">30309</a>.</li>
<li>Replace hs_desc_link_specifier_t with link_specifier_t, and remove all hs_desc_link_specifier_t-specific code. Fixes bug <a href="https://bugs.torproject.org/22781">22781</a>; bugfix on 0.3.2.1-alpha.</li>
<li>Simplify v3 onion service link specifier handling code. Fixes bug <a href="https://bugs.torproject.org/23576">23576</a>; bugfix on 0.3.2.1-alpha.</li>
<li>Split crypto_digest.c into NSS code, OpenSSL code, and shared code. Resolves ticket <a href="https://bugs.torproject.org/29108">29108</a>.</li>
<li>Split control.c into several submodules, in preparation for distributing its current responsibilities throughout the codebase. Closes ticket <a href="https://bugs.torproject.org/29894">29894</a>.</li>
<li>Start to move responsibility for knowing about periodic events to the appropriate subsystems, so that the mainloop doesn't need to know all the periodic events in the rest of the codebase. Implements tickets 30293 and 30294.</li>
</ul>
</li>
<li>Documentation:
<ul>
<li>Document how to find git commits and tags for bug fixes in CodingStandards.md. Update some file documentation. Closes ticket <a href="https://bugs.torproject.org/30261">30261</a>.</li>
</ul>
</li>
<li>Removed features:
<ul>
<li>Remove the linux-tor-prio.sh script from contrib/operator-tools directory. Resolves issue <a href="https://bugs.torproject.org/29434">29434</a>.</li>
<li>Remove the obsolete OpenSUSE initscript. Resolves issue <a href="https://bugs.torproject.org/30076">30076</a>.</li>
<li>Remove the obsolete script at contrib/dist/tor.sh.in. Resolves issue <a href="https://bugs.torproject.org/30075">30075</a>.</li>
</ul>
</li>
<li>Code simplification and refactoring (shell scripts):
<ul>
<li>Clean up many of our shell scripts to fix shellcheck warnings. These include autogen.sh (ticket <a href="https://bugs.torproject.org/26069">26069</a>), test_keygen.sh (ticket <a href="https://bugs.torproject.org/29062">29062</a>), test_switch_id.sh (ticket <a href="https://bugs.torproject.org/29065">29065</a>), test_rebind.sh (ticket <a href="https://bugs.torproject.org/29063">29063</a>), src/test/fuzz/minimize.sh (ticket <a href="https://bugs.torproject.org/30079">30079</a>), test_rust.sh (ticket <a href="https://bugs.torproject.org/29064">29064</a>), torify (ticket <a href="https://bugs.torproject.org/29070">29070</a>), asciidoc-helper.sh (29926), fuzz_multi.sh (30077), fuzz_static_testcases.sh (ticket <a href="https://bugs.torproject.org/29059">29059</a>), nagios-check-tor-authority-cert (ticket <a href="https://bugs.torproject.org/29071">29071</a>), src/test/fuzz/fixup_filenames.sh (ticket <a href="https://bugs.torproject.org/30078">30078</a>), test-network.sh (ticket <a href="https://bugs.torproject.org/29060">29060</a>), test_key_expiration.sh (ticket <a href="https://bugs.torproject.org/30002">30002</a>), zero_length_keys.sh (ticket <a href="https://bugs.torproject.org/29068">29068</a>), and test_workqueue_*.sh (ticket <a href="https://bugs.torproject.org/29067">29067</a>).</li>
</ul>
</li>
<li>Testing (chutney):
<ul>
<li>In "make test-network-all", test IPv6-only v3 single onion services, using the chutney network single-onion-v23-ipv6-md. Closes ticket <a href="https://bugs.torproject.org/27251">27251</a>.</li>
</ul>
</li>
</ul>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/releases">
          releases
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-282160"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-282160" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Caleb (not verified)</span> said:</p>
      <p class="date-time">May 28, 2019</p>
    </div>
    <a href="#comment-282160">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-282160" class="permalink" rel="bookmark">Sorry Tor Noob here, does…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Sorry Tor Noob here, does anyone know how to turn off bridges?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-282190"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-282190" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  wayward
  </article>
    <div class="comment-header">
      <p class="comment__submitted">wayward said:</p>
      <p class="date-time">May 29, 2019</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-282160" class="permalink" rel="bookmark">Sorry Tor Noob here, does…</a> by <span>Caleb (not verified)</span></p>
    <a href="#comment-282190">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-282190" class="permalink" rel="bookmark">Are you using Tor Browser…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Are you using Tor Browser for Android, or Tor Browser for desktop? If you're using the desktop browser, you can find some instructions on how to turn off bridges here: <a href="https://tb-manual.torproject.org/bridges/" rel="nofollow">https://tb-manual.torproject.org/bridges/</a></p>
<p>If you're already connected to the Tor network:<br />
1. Click the onion button next to the Tor URL bar<br />
2. Select "Tor Network Settings..."<br />
3. Deselect "Tor is censored in my country."</p>
<p>If you're starting Tor for the first time, click "Configure," then deselect "Tor is censored in my country."<br />
If you're stuck on the loading bar when starting Tor, click "Cancel," then "Configure," and then deselect "Tor is censored in my country."</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-282194"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-282194" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">May 29, 2019</p>
    </div>
    <a href="#comment-282194">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-282194" class="permalink" rel="bookmark">The padding is awesome! Are…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>The padding is awesome! Are there plans for it to be extended like in the original WTF-Pad paper to deal with website fingerprinting?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-282202"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-282202" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">May 30, 2019</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-282194" class="permalink" rel="bookmark">The padding is awesome! Are…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-282202">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-282202" class="permalink" rel="bookmark">Yes. Actually, what we…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Yes. Actually, what we implemented is a generalization/extension of WTF-Pad, to support many similar types of state machine based event-driven padding schemes (see for example: <a href="https://www.cs.kau.se/pulls/hot/thebasketcase-ape/" rel="nofollow">https://www.cs.kau.se/pulls/hot/thebasketcase-ape/</a>).</p>
<p>While the overhead of WTF-Pad was low, it has always been my belief that it can be optimized further, especially for specific use cases. So I don't expect the final implementation to be exactly like WTF-Pad, but I am hopeful that this generalization will support an even more efficient approach.</p>
<p>We will be writing documentation to help researchers create such systems soon. See <a href="https://trac.torproject.org/projects/tor/ticket/28804" rel="nofollow">https://trac.torproject.org/projects/tor/ticket/28804</a> if you want to follow along with that effort.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-282268"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-282268" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>LX1 (not verified)</span> said:</p>
      <p class="date-time">June 04, 2019</p>
    </div>
    <a href="#comment-282268">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-282268" class="permalink" rel="bookmark">Hello, you can return…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Hello, you can return description label<br />
</p>
<blockquote>new</blockquote>
<p> in NYX and nice icon lab in metrics relay site or think differently? We running alpha dev relays bridge and hs service and new labels<br />
</p>
<blockquote>unrecommended</blockquote>
<p> in terminal look aren't nice. Please consider testers and researchers. Thank you.</p>
</div>
  </div>
</article>
<!-- Comment END -->
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
